import { useEffect, useReducer } from 'react';
import { addCustomEventListener, removeCustomEventListener } from '../../../utils/customEventDispatcher';
import { DUMMY_OBJECT } from '../../../utils/constants';
import { DOT_SERVICE_EVENT } from '../../../service/helpers/constant';
import attachmentViewerReducer from '../reducers/attachmentViewerReducer';

const useDOTAttachmentViewerService = () => {
  const [attachment, dispatch] = useReducer(attachmentViewerReducer);

  const handleService = event => {
    const {
      type,
      payload
    } = event.detail;
    dispatch({
      type,
      payload
    });
  };

  useEffect(() => {
    addCustomEventListener({
      eventName: DOT_SERVICE_EVENT,
      callback: handleService
    });
    return () => {
      removeCustomEventListener({
        eventName: DOT_SERVICE_EVENT,
        callback: handleService
      });
    };
  }, []);
  return {
    attachment
  };
};

export default useDOTAttachmentViewerService;